"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var oda_gen_common_1 = require("oda-gen-common");
var deepMerge = oda_gen_common_1.lib.deepMerge;
var graphql_tools_1 = require("graphql-tools");
var lodash_1 = require("./lodash");
var LodashSchema = (function (_super) {
    __extends(LodashSchema, _super);
    function LodashSchema() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._name = 'LodashSchema';
        _this._composite = [
            new oda_gen_common_1.types.DefaultTypes({}),
            new lodash_1.LodashModule({}),
        ];
        return _this;
    }
    Object.defineProperty(LodashSchema.prototype, "typeDefs", {
        get: function () {
            return "\n      " + this.typeDef.join('\n  ') + "\n\n      type RootQuery {\n        dummy: String\n      }\n\n      schema {\n        query: RootQuery\n      }\n      ";
        },
        enumerable: true,
        configurable: true
    });
    LodashSchema.prototype.build = function () {
        _super.prototype.build.call(this);
        this._resolver = deepMerge(this.resolver, {
            RootQuery: this.query,
        });
    };
    Object.defineProperty(LodashSchema.prototype, "resolvers", {
        get: function () {
            return this.applyHooks(this.resolver);
        },
        enumerable: true,
        configurable: true
    });
    return LodashSchema;
}(oda_gen_common_1.types.GQLModule));
var _lodashAST;
function lodashAST() {
    if (!_lodashAST) {
        var current = new LodashSchema({});
        current.build();
        var schema = graphql_tools_1.makeExecutableSchema({
            typeDefs: current.typeDefs.toString(),
            resolvers: current.resolvers,
            resolverValidationOptions: {
                requireResolversForNonScalar: false,
            },
        });
        _lodashAST = schema.getDirective('_');
    }
    return _lodashAST;
}
exports.lodashAST = lodashAST;
//# sourceMappingURL=schema.js.map